spec:
  inputs:
    stage:
      default: validate
---

yamlfmt:
  stage: $[[ inputs.stage ]]
  needs: []
  image:
    name: ${CI_REGISTRY}/gitlab-com/gl-infra/common-ci-tasks-images/yamlfmt:${GL_ASDF_YAMLFMT_VERSION}
    entrypoint: [""]
  script:
    - |
      # Terminal colors
      bright_red="$(printf "\e[31;1m")"
      blue="$(printf "\e[34m")"
      color_reset="$(printf "\e[0m")"
    - |
      # Dump yamlfmt config
      echo "# /etc/yamlfmt.yaml"
      echo -n "${blue}"
      cat /etc/yamlfmt.yaml
      echo -n "${color_reset}"
    - |
      # Dump pattern file
      PATTERN_FILES=("/etc/yamlfmt.patterns")
      if [[ -e .yamlfmt.patterns ]]; then
        PATTERN_FILES+=(".yamlfmt.patterns")
      fi
      for pattern_file in "${PATTERN_FILES[@]}"; do
        echo "# ${pattern_file}"
        echo -n "${blue}"
        cat "${pattern_file}"
        echo -n "${color_reset}"
      done
    - yamlfmt -conf /etc/yamlfmt.yaml "${PATTERN_FILES[@]}"
    - git diff | tee yamlfmt.patch
    - |
      if [[ -s yamlfmt.patch ]]; then
        echo "${bright_red}Some YAML files are not formatted correctly. Run the following command in the repository root to fix:${color_reset}"
        echo "${bright_red}# curl ${CI_PROJECT_URL}/-/jobs/${CI_JOB_ID}/artifacts/raw/yamlfmt.patch | patch -p1${color_reset}"
        exit 1
      fi
  after_script: |
    cat <<-EOD
    ----------------------------------------------------------
    Need help? Documentation on the yamlfmt CI job can be found at:
    https://gitlab.com/gitlab-com/gl-infra/common-ci-tasks/-/blob/main/yamlfmt.md
    EOD
  rules:
    - if: '$GL_ASDF_YAMLFMT_VERSION == null || $GL_ASDF_YAMLFMT_VERSION == ""'
      when: 'never'
    - if: '$CI_PIPELINE_SOURCE == "schedule"'
      when: 'never'
    - if: '($CI_PIPELINE_SOURCE == "merge_request_event") || ($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH)'
  allow_failure: true
  artifacts:
    paths:
      - yamlfmt.patch
    expose_as: 'yamlfmt patch'
    when: on_failure
